static int	newExpandFKey = defExpandFKey;

long WINAPI KeyPressDlgProc (HANDLE hDlg, int Msg, int Param1, long Param2)
{
	char					KeyText[50];
	static int		LastKey;
	static DWORD	*KMParam = NULL;
	bool					gotoM1 = false;
	if (Msg == DN_INITDIALOG)
	{
		KMParam = (DWORD *) Param2;
		LastKey = 0;

		static const char *const	PreDefKeyName[] = { "CtrlDown" };
		for (int i = 0; i < dimOf (PreDefKeyName); i++)
			Info.SendDlgMessage (hDlg, DM_LISTADDSTR, 2, (long) PreDefKeyName[i]);
		FSF.FarKeyToName (*KMParam, KeyText, 0);
		Info.SendDlgMessage (hDlg, DM_SETTEXTPTR, 2, (long) KeyText);
	}
	else if (Param1 == 2 && Msg == DN_EDITCHANGE)
	{
		LastKey = 0;
		Param2 = FSF.FarNameToKey (((FarDialogItem *) Param2)->Data);
		if (Param2 != -1) gotoM1 = true;
	}
	else if (Msg == DN_KEY)
	{
		if (Param2 == KEY_ESC || Param2 == KEY_ENTER && LastKey == KEY_ENTER || Param2 == KEY_CTRLDOWN || Param2 == KEY_F1)
			return (FALSE);
		if (Param2 == KEY_ENTER && LastKey && LastKey != KEY_ENTER) return (FALSE);
		gotoM1 = true;
	}
	else if (Msg == DN_CTLCOLORDLGITEM)
	{
		Param2 &= 0xFF00FFFFU;
		Param2 |= (Param2 & 0xFF) << 16;
		return (Param2);
	}

	if (gotoM1)
	{
		FSF.FarKeyToName (Param2, KeyText, 0);

		DWORD key = (DWORD) Param2;
		int		msg = MGetKeyPrompt;
		if ((key &~(KEY_CTRL | KEY_RCTRL | KEY_SHIFT | KEY_ALT | KEY_RALT)) == 0)
			msg = MGetKeyError;
		else
		{
			switch (key)
			{
			case KEY_ALTF5:
			case KEY_ALTF9:
			case KEY_ALTF11:
			case KEY_ALTSHIFTF9:
			case KEY_CTRLF10:
			case KEY_CTRLO:
			case KEY_CTRLSHIFTTAB:
			case KEY_CTRLTAB:
			case KEY_CTRLW:
			case KEY_F10:
			case KEY_F11:
			case KEY_F12:
			case KEY_F2:
			case KEY_F6:
			case KEY_SHIFTF10:
			case KEY_SHIFTF2:
			case KEY_ENTER:
				msg = MGetKeyError;
				break;
			}
		}

		if (msg == MGetKeyPrompt)
		{
			char	KeyName[512];
			HKEY	hKey;
			if (RegOpenKeyEx (HKEY_CURRENT_USER, "Software\\Far\\KeyMacros\\Editor", 0, KEY_READ, &hKey) == ERROR_SUCCESS)
			{
				bool	cont = true;
				for (DWORD i = 0; cont; i++)
				{
					DWORD size = sizeof (KeyName);
					LONG	res = RegEnumKeyEx (hKey, i, KeyName, &size, NULL, NULL, NULL, NULL);
					switch (res)
					{
					case ERROR_SUCCESS:
						if (!lstrcmp (KeyName, KeyText))
						{
							msg = MGetKeyMacros;
							cont = false;
						}
						break;
					case ERROR_NO_MORE_ITEMS:
						cont = false;
						break;
					default:
						cont = false;
						break;
					}
				}
			}

			RegCloseKey (hKey);
		}

		Info.SendDlgMessage (hDlg, DM_SETTEXTPTR, 1, (long) GetMsg (msg));
		*KMParam = key;
		Info.SendDlgMessage (hDlg, DM_SETTEXTPTR, 2, (long) KeyText);
		Info.SendDlgMessage (hDlg, DM_REDRAW, 0, 0);
		LastKey = Param2;
		return (TRUE);
	}

	return (Info.DefDlgProc (hDlg, Msg, Param1, Param2));
}

#define CFG_KEYBUTTON 9
#define CFG_KEYPROMPT 10

long WINAPI ConfigDlgProc (HANDLE hDlg, int Msg, int Param1, long Param2)
{
	char	KeyText[50];
	switch (Msg)
	{
	case DN_BTNCLICK:
		if (Param1 == CFG_KEYBUTTON)
		{
			FSF.FarKeyToName (newExpandFKey, KeyText, 0);

			InitDialogItem	InitItems[] =
			{
				{ DI_DOUBLEBOX, 3, 1, 40, 4, 0, 0, (char *) MKey }, { DI_TEXT, 5, 2, 0, 0, 0, 0, (char *) MGetKeyPrompt },
				{ DI_COMBOBOX, 5, 3, 38, 3, 1, 0, KeyText }
			};
			DWORD						newKey = newExpandFKey;
			int							ExitCode = ExecDialogEx
				(
					InitItems,
					dimOf (InitItems),
					2,
					2,
					NULL,
					KeyPressDlgProc,
					(long) &newKey
				);
			if (ExitCode != -1)
			{
				FSF.FarKeyToName (newExpandFKey = newKey, KeyText, 0);
				Info.SendDlgMessage (hDlg, DM_SETTEXTPTR, CFG_KEYPROMPT, (long) &KeyText);
				Info.SendDlgMessage (hDlg, DM_REDRAW, 0, 0);
			}

			return (TRUE);
		}
		break;
	}

	return (Info.DefDlgProc (hDlg, Msg, Param1, Param2));
}

int Config (void)
{
	char	KeyText[50];
	FSF.FarKeyToName (newExpandFKey = defExpandFKey, KeyText, 0);

	InitDialogItem	InitItems[] =
	{
		{ DI_DOUBLEBOX, 3, 1, 65, 14, 0, 0, (char *) MTitle },
		{ /* 1 */ DI_CHECKBOX, 5, 2, 0, 0, autocompile, 0, (char *) MAutoCompile },
		{ /* 2 */ DI_CHECKBOX, 5, 3, 0, 0, autoformat, 0, (char *) MAutoFormat },
		{ /* 3 */ DI_CHECKBOX, 5, 4, 0, 0, pluginStop, 0, (char *) MDisable },
		{ /* 4 */ DI_CHECKBOX, 5, 5, 0, 0, scrollStop, 0, (char *) MPause },
		{ /* 5 */ DI_CHECKBOX, 5, 6, 0, 0, ignoreposn, 0, (char *) MIgnorePos },
		{ /* 6 */ DI_CHECKBOX, 5, 7, 0, 0, outputmenu, 0, (char *) MOutputMenu },
		{ /* 7 */ DI_CHECKBOX, 5, 8, 0, 0, filterring, 0, (char *) MFiltering },
		{ /* 8 */ DI_TEXT, 5, 9, 0, 255, 0, 0, NULL }, { /* 9 */ DI_BUTTON, 5, 10, 0, 0, 0, 0, (char *) MKey },
		{ /* 10 */ DI_TEXT, 30, 10, 0, 0, 0, 0, KeyText }, { /* 11 */ DI_TEXT, 5, 11, 0, 255, 0, 0, NULL },
		{ /* 12 */ DI_BUTTON, 5, 12, 63, 0, 0, DIF_CENTERGROUP, (char *) MNavConfig },
		{ /* 13 */ DI_TEXT, 5, 13, 0, 255, 0, 0, NULL }, /* 14 - OK */ { DI_BUTTON, 0, 14, 0, 0, 0, DIF_CENTERGROUP, (char *) MOK },
		{ /* 15 */ DI_BUTTON, 0, 14, 0, 0, 0, DIF_CENTERGROUP, (char *) MCancel }
	};
	const int				NV = 12;
	const int				OK = 14;
	while (true)
	{
		int ExitCode = ExecDialogEx (InitItems, dimOf (InitItems), 1, OK, NULL, ConfigDlgProc, NULL);
		if (ExitCode == NV)
		{
			char	navRectLeft[32];
			char	navRectRight[32];
			char	navRectTop[32];
			char	navRectBottom[32];
			GetRegKey (HKEY_CURRENT_USER, "", "NavigationRectLeft", navRectLeft, "0", 32);
			GetRegKey (HKEY_CURRENT_USER, "", "NavigationRectTop", navRectTop, "50", 32);
			GetRegKey (HKEY_CURRENT_USER, "", "NavigationRectRight", navRectRight, "100", 32);
			GetRegKey (HKEY_CURRENT_USER, "", "NavigationRectBottom", navRectBottom, "100", 32);

			struct InitDialogItemEx InitItems[] =
			{ //Type X1 Y1 X2 Y2 Fo Se Fl DB Data
				{ /* 00 */ DI_DOUBLEBOX, 3, 1, 55, 12, 0, 0, DIF_BOXCOLOR, 0, GetMsg (MNavConfig), NULL },
				{ /* 01 */ DI_TEXT, 5, 2, 0, 0, 0, 0, 0, 0, GetMsg (MNavRectLeft), NULL },
				{ /* 02 */ DI_FIXEDIT, 5, 3, 8, 0, 0, 0, DIF_HISTORY, 0, navRectLeft, "True-Tpl.History.Navigation.Rect.Left" },
				{ /* 03 */ DI_TEXT, 5, 4, 0, 0, 0, 0, 0, 0, GetMsg (MNavRectTop), NULL },
				{ /* 04 */ DI_FIXEDIT, 5, 5, 8, 0, 0, 0, DIF_HISTORY, 0, navRectTop, "True-Tpl.History.Navigation.Rect.Top" },
				{ /* 05 */ DI_TEXT, 5, 6, 0, 0, 0, 0, 0, 0, GetMsg (MNavRectRight), NULL },
				{ /* 06 */ DI_FIXEDIT, 5, 7, 8, 0, 0, 0, DIF_HISTORY, 0, navRectRight,
						"True-Tpl.History.Navigation.Rect.Right" },
				{ /* 07 */ DI_TEXT, 5, 8, 0, 0, 0, 0, 0, 0, GetMsg (MNavRectBottom), NULL },
				{ /* 08 */ DI_FIXEDIT, 5, 9, 8, 0, 0, 0, DIF_HISTORY, 0, navRectBottom,
						"True-Tpl.History.Navigation.Rect.Bottom" },
				{ /* 09 */ DI_TEXT, 0, 10, 0, 0, 0, 0, DIF_BOXCOLOR | DIF_SEPARATOR, 0, "", NULL },
				{ /* 10 */ DI_BUTTON, 0, 11, 0, 0, 0, 0, DIF_CENTERGROUP, 1, GetMsg (MOK), NULL },
				{ /* 11 */ DI_BUTTON, 0, 11, 0, 0, 0, 0, DIF_CENTERGROUP, 0, GetMsg (MCancel), NULL }
			};
			struct FarDialogItem		DialogItems[(sizeof (InitItems) / sizeof (InitItems[0]))];
			InitDialogItemsEx (InitItems, DialogItems, (sizeof (InitItems) / sizeof (InitItems[0])));

			int n = Info.Dialog
				(
					Info.ModuleNumber,
					-1,
					-1,
					59,
					14,
					NULL,
					DialogItems,
					(sizeof (InitItems) / sizeof (InitItems[0]))
				);
			if (n == 10)
			{
				SetRegKey (HKEY_CURRENT_USER, "", "NavigationRectLeft", DialogItems[2].Data);
				SetRegKey (HKEY_CURRENT_USER, "", "NavigationRectTop", DialogItems[4].Data);
				SetRegKey (HKEY_CURRENT_USER, "", "NavigationRectRight", DialogItems[6].Data);
				SetRegKey (HKEY_CURRENT_USER, "", "NavigationRectBottom", DialogItems[8].Data);
			}

			continue;
		}

		if (ExitCode == OK)
		{
			SetRegKey (HKEY_CURRENT_USER, "", "AutoCompile", autocompile = InitItems[1].Selected);
			SetRegKey (HKEY_CURRENT_USER, "", "AutoFormat", autoformat = InitItems[2].Selected);
			SetRegKey (HKEY_CURRENT_USER, "", "Disable", pluginStop = InitItems[3].Selected);
			SetRegKey (HKEY_CURRENT_USER, "", "UseScrollLock", scrollStop = InitItems[4].Selected);
			SetRegKey (HKEY_CURRENT_USER, "", "IgnorePosition", ignoreposn = InitItems[5].Selected);
			SetRegKey (HKEY_CURRENT_USER, "", "OutputMenu", outputmenu = InitItems[6].Selected);
			SetRegKey (HKEY_CURRENT_USER, "", "OutputFilter", filterring = InitItems[7].Selected);
			SetRegKey (HKEY_CURRENT_USER, "", "Key", defExpandFKey = newExpandFKey);
			DoneMacro ();
			InitMacro ();
			return (true);
		}
		else
			break;
	}

	return (false);
}
