struct TFormat
{
	TFormat();
	char	name[MAX_STR_LEN];
	char	comm[MAX_STR_LEN];
	bool	echo;
};

TFormat::TFormat ()
{
	lstrcpy (this->name, "");
	lstrcpy (this->comm, "");
	this->echo = true;
}

static void runFormatting (TFormat *tf, const char *Name = NULL)
{
	char	old_cmd[MAX_STR_LEN];
	char	new_cmd[MAX_STR_LEN];
	lstrcpy (old_cmd, tf->comm);
	nullUserStrings ();
	if (!scanUserInput (false, '=', old_cmd)) return ;

	char						filename[NM];
	FILE						*dstfile;
	FILE						*srcfile;
	int							vblock;
	int							strcount;
	TEditorPos			epos, epos_sel;
	EditorInfo			ei;
	EditorGetString egs;

	if (Name == NULL)
	{
		Info.EditorControl (ECTL_GETINFO, &ei);
		if (ei.BlockType != BTYPE_NONE)
		{
			EditorSaveSelected ();
			EditorGetStr (&egs, ei.BlockStartLine);
			epos_sel = epos = EditorGetPos ();
			epos_sel.Row = ei.BlockStartLine;
			epos_sel.Col = egs.SelStart;
		}
		else
		{
			EditorSaveAll ();
			epos_sel = epos = EditorGetPos ();
			epos_sel.Row = 0;
			epos_sel.Col = 0;
		}

		lstrcpy (filename, TEMP_TT_TMP);
		FSF.ExpandEnvironmentStr (filename, filename, sizeof (filename));
		srcfile = fopen (filename, "rb");
		if (srcfile == NULL) return ;
		lstrcpy (filename, TEMP_TT_SRC_TMP);
		FSF.ExpandEnvironmentStr (filename, filename, sizeof (filename));
		dstfile = fopen (filename, "wt");
		if (dstfile == NULL) return ;
		fread (&vblock, 1, sizeof (int), srcfile);
		fread (&strcount, 1, sizeof (int), srcfile);
		for (int i = 0; i < strcount; i++)
		{
			char	tmp;
			if (i != 0) fputc ('\n', dstfile);

			int len;
			fread (&len, 1, sizeof (int), srcfile);
			for (int i = 0; i < len; i++)
			{
				fread (&tmp, 1, sizeof (char), srcfile);
				putc (tmp, dstfile);
			}
		}

		fclose (dstfile);
		fclose (srcfile);
	}
	else
	{
		lstrcpy (filename, TEMP_TT_SRC_TMP);
		FSF.ExpandEnvironmentStr (filename, filename, sizeof (filename));
		CopyFile (Name, filename, FALSE);
	}

	char	*p_old = old_cmd;
	char	*p_new = new_cmd;
	*p_new = '\0';
	lstrcat (p_new, "%COMSPEC% /C ");
	p_new += lstrlen ("%COMSPEC% /C ");
	while (*p_old)
	{
		if (*p_old == '=')
		{
			p_old++;
			if (*p_old == '=')
			{
				*p_new = '=';
				p_new++;
				p_old++;
			}

			if ((*p_old == 'D') || (*p_old == 'd'))
			{
				*p_new = '\0';
				lstrcat (p_new, TEMP_TT_DST_TMP);
				p_new += lstrlen (TEMP_TT_DST_TMP);
				p_old++;
			}

			if ((*p_old == 'S') || (*p_old == 's'))
			{
				*p_new = '\0';
				lstrcat (p_new, TEMP_TT_SRC_TMP);
				p_new += lstrlen (TEMP_TT_SRC_TMP);
				p_old++;
			}

			if (*p_old == '?')
			{
				p_old++;
				while ((*p_old) && (!((*p_old == '?') && (*(p_old - 1) != '\\')))) p_old++;
				p_old++;
			}

			if ((*p_old >= '0') && (*p_old <= '9'))
			{
				*p_new = '\0';
				lstrcat (p_new, userString[*p_old - '0']);
				p_new += lstrlen (userString[*p_old - '0']);
				p_old++;
			}
		}
		else
		{
			*p_new = *p_old;
			p_new++;
			p_old++;
		}
	}

	*p_new = '\0';
	FSF.ExpandEnvironmentStr (new_cmd, new_cmd, sizeof (new_cmd));

	ShowFlag = tf->echo;
	ClearFlag = tf->echo;

	HANDLE	hScreen = Info.SaveScreen (0, 0, -1, -1);
	SetConsoleTitle (new_cmd);

	DWORD OldConsoleMode;
	GetConsoleMode (GetStdHandle (STD_INPUT_HANDLE), &OldConsoleMode);
	SetConsoleMode
	(
		GetStdHandle (STD_INPUT_HANDLE),
		ENABLE_PROCESSED_INPUT | ENABLE_LINE_INPUT | ENABLE_ECHO_INPUT | ENABLE_MOUSE_INPUT
	);
	ProcessInstall ();

	STARTUPINFO					si;
	PROCESS_INFORMATION pi;
	memset (&si, 0, sizeof (si));
	memset (&pi, 0, sizeof (pi));
	si.cb = sizeof (si);
	si.dwFlags = STARTF_USESTDHANDLES;
	si.hStdOutput = GetStdHandle (STD_OUTPUT_HANDLE);
	si.hStdInput = GetStdHandle (STD_INPUT_HANDLE);
	si.hStdError = GetStdHandle (STD_ERROR_HANDLE);
	if
	(
		CreateProcess
			(
				NULL,
				new_cmd,
				NULL,
				NULL,
				TRUE,
				CREATE_NO_WINDOW | NORMAL_PRIORITY_CLASS,
				NULL,
				NULL,
				&si,
				&pi
			) == TRUE
	)
	{
		WaitForSingleObject (pi.hProcess, INFINITE);
		CloseHandle (pi.hThread);
		CloseHandle (pi.hProcess);
		putc ('\n', stdout);
	}

	ProcessUninstall ();
	SetConsoleMode (GetStdHandle (STD_INPUT_HANDLE), OldConsoleMode);
	if (ShowFlag) Info.Control (NULL, FCTL_SETUSERSCREEN, NULL);
	Info.RestoreScreen (hScreen);
	redraw ();

	if (Name == NULL)
	{
		if (ei.BlockType != BTYPE_NONE)
		{
			Info.EditorControl (ECTL_DELETEBLOCK, NULL);
			EditorSetPos (epos_sel);
		}
		else
		{
			EditorSelect		es;
			EditorGetString last;

			EditorGetStr (&last, 0);
			es.BlockType = BTYPE_STREAM;
			es.BlockStartLine = 0;
			es.BlockStartPos = 0;
			es.BlockHeight = ei.TotalLines;
			es.BlockWidth = last.StringLength;
			Info.EditorControl (ECTL_SELECT, (void *) &es);
			Info.EditorControl (ECTL_DELETEBLOCK, NULL);
			EditorSetPos (epos_sel);
		}

		lstrcpy (filename, TEMP_TT_DST_TMP);
		FSF.ExpandEnvironmentStr (filename, filename, sizeof (filename));
		dstfile = fopen (filename, "rt");
		if (dstfile == NULL) return ;

		char				c[2] = "x";
		TEditorPos	ep = EditorGetPos ();
		Info.EditorControl (ECTL_GETINFO, &ei);

		int codeTable = EditorGetCodeTable ();
		EditorSetCodeTable (1);					//set dos code table (for normal restoring non-latin text)

		while ((c[0] = fgetc (dstfile)) != EOF)
		{
			if (c[0] != '\n')
				Info.EditorControl (ECTL_INSERTTEXT, c);
			else
			{
				if (vblock == 0)
				{
					Info.EditorControl (ECTL_INSERTSTRING, 0);
				}
				else
				{
					ep.Row++;
					if (ep.Row >= ei.TotalLines) Info.EditorControl (ECTL_INSERTSTRING, 0);
					EditorSetPos (ep);
				}
			}
		}

		fclose (dstfile);
		EditorSetCodeTable (codeTable); //restore editor code table
		Info.EditorControl (ECTL_GETINFO, &ei);
		if (epos.Row >= ei.TotalLines) epos.Row = ei.TotalLines - 1;
		EditorGetStr (&egs, epos.Row);
		if (epos.Col >= egs.StringLength) epos.Col = egs.StringLength - 1;
		EditorSetPos (epos);
		EditorSaveRemove ();
	}
	else
	{
		lstrcpy (filename, TEMP_TT_DST_TMP);
		FSF.ExpandEnvironmentStr (filename, filename, sizeof (filename));
		CopyFile (filename, Name, FALSE);
	}

	lstrcpy (filename, TEMP_TT_SRC_TMP);
	FSF.ExpandEnvironmentStr (filename, filename, sizeof (filename));
	unlink (filename);
	lstrcpy (filename, TEMP_TT_DST_TMP);
	FSF.ExpandEnvironmentStr (filename, filename, sizeof (filename));
	unlink (filename);
}

static void SelectFormatting (TEInfo *te)
{
	if (te)
	{
		TLang *lng = (TLang *) (langColl[te->lang]);
		if (lng)
		{
			if ((autoformat) && (lng->formatColl.getCount () == 1))
			{
				runFormatting ((TFormat *) lng->formatColl[0]);
				return ;
			}

			if (lng->formatColl.getCount () > 0)
			{
				FarMenuItem *amenu = new FarMenuItem[lng->formatColl.getCount ()];
				if (amenu)
				{
					for (unsigned i = 0; i < lng->formatColl.getCount (); i++)
					{
						TFormat *mm = (TFormat *) (lng->formatColl[i]);
						FSF.sprintf (amenu[i].Text, "%s", mm->name);
						amenu[i].Selected = false;
						amenu[i].Checked = amenu[i].Separator = false;
					}

					int res = Info.Menu
						(
							Info.ModuleNumber,
							-1,
							-1,
							0,
							FMENU_WRAPMODE,
							GetMsg (MSelectFormatter),
							NULL,
							NULL,
							NULL,
							NULL,
							amenu,
							lng->formatColl.getCount ()
						);
					if (res != -1) runFormatting ((TFormat *) lng->formatColl[res]);
					delete[] amenu;
				}
			}
		}
	}
}

static void FormatMenu (const char *Name, int lang)
{
	TLang *lng = (TLang *) (langColl[lang]);
	if (lng)
	{
		if ((autoformat) && (lng->formatColl.getCount () == 1))
		{
			runFormatting ((TFormat *) lng->formatColl[0], Name);
			return ;
		}

		if (lng->formatColl.getCount () > 0)
		{
			FarMenuItem *amenu = new FarMenuItem[lng->formatColl.getCount ()];
			if (amenu)
			{
				for (unsigned i = 0; i < lng->formatColl.getCount (); i++)
				{
					TFormat *mm = (TFormat *) (lng->formatColl[i]);
					FSF.sprintf (amenu[i].Text, "%s", mm->name);
					amenu[i].Selected = false;
					amenu[i].Checked = amenu[i].Separator = false;
				}

				int res = Info.Menu
					(
						Info.ModuleNumber,
						-1,
						-1,
						0,
						FMENU_WRAPMODE,
						GetMsg (MSelectFormatter),
						NULL,
						NULL,
						NULL,
						NULL,
						amenu,
						lng->formatColl.getCount ()
					);
				if (res != -1) runFormatting ((TFormat *) lng->formatColl[res], Name);
				delete[] amenu;
			}
		}
	}
}
