//If this code works, it was written by Alexander Nazarenko. If not, I don't know who wrote it. ;
//  ⨢ True-Cpp plugin. (c) Andrey Tretjakov,1999 v.1.0
#include "winmem.h"

#define _FAR_USE_FARFINDDATA

#include <plugin.hpp>
#include <farkeys.hpp>

#include "eicoll.h"
#include "true-tpl.h"
#include "ttpl-lng.h"
#include "farintf.h"
#include "console.h"
#include "lstring.h"
#include "stdio.h"
#include "cregexp.h"
#include "syslog.h"
#include "objbase.h"
#include "process.h"

static HINSTANCE	hInst;
bool							IsOldFar = true;
char							szIni[_MAX_PATH]; //Plugin INI filename
const char				cMD = '@';				//Macro delimiter

#define expAnyWhere			".*\\b\\p.*"
#define expAtStart			"\\p.*"
#define expAtMiddle			"\\S.*\\b\\p.*\\S"
#define expAtEnd				".*\\b\\p"
#define expOnBlank			"\\p"

#define TEMP_TT_TMP			"%TEMP%\\true-template.tmp"
#define TEMP_TT_SRC_TMP "%TEMP%\\true-template-src.tmp"
#define TEMP_TT_DST_TMP "%TEMP%\\true-template-dst.tmp"

#define MAX_REG_LEN			512
#define MAX_STR_LEN			8192

static int				defExpandFKey = KEY_SPACE;

static int				pluginBusy = 0;
static int				pluginStop = 0;
static int				scrollStop = 0;
static int				ignoreposn = 0;
static int				outputmenu = 0;
static int				filterring = 0;
static int				autocompile = 0;
static int				autoformat = 0;

#include "editor.cpp"
#include "str.cpp"
#include "files.cpp"
#include "defs.cpp"
#include "userinput.cpp"
#include "exec.cpp"
#include "lang.cpp"
#include "compiler.cpp"
#include "format.cpp"
#include "navy.cpp"
#include "reload.cpp"
#include "parse.cpp"
#include "macro.cpp"
#include "commands.cpp"
#include "comments.cpp"
#include "editorinput.cpp"
#include "config.cpp"

int WINAPI _export GetMinFarVersion (void)
{
	return (FARMANAGERVERSION);
}

void WINAPI _export SetStartupInfo (const PluginStartupInfo *Info)
{
	::Info = *Info;
	IsOldFar = true;
	if (Info->StructSize >= sizeof (PluginStartupInfo))
	{
		::FSF = *Info->FSF;
		::Info.FSF = &::FSF;
		IsOldFar = false;
		FSF.sprintf (PluginRootKey, "%s\\TRUE-TPL", Info->RootKey);
		GetRegKey (HKEY_CURRENT_USER, "", "AutoCompile", autocompile, 1);
		GetRegKey (HKEY_CURRENT_USER, "", "AutoFormat", autoformat, 1);
		GetRegKey (HKEY_CURRENT_USER, "", "Disable", pluginStop, 0);
		GetRegKey (HKEY_CURRENT_USER, "", "UseScrollLock", scrollStop, 1);
		GetRegKey (HKEY_CURRENT_USER, "", "IgnorePosition", ignoreposn, 1);
		GetRegKey (HKEY_CURRENT_USER, "", "OutputMenu", outputmenu, 1);
		GetRegKey (HKEY_CURRENT_USER, "", "OutputFilter", filterring, 1);
		GetRegKey (HKEY_CURRENT_USER, "", "Key", defExpandFKey, KEY_SPACE);
		InitMacro ();
	}
}

void WINAPI _export GetPluginInfo (PluginInfo *Info)
{
	if (!IsOldFar)
	{
		static const char *PluginMenuStrings[1];
		Info->StructSize = sizeof (*Info);
		Info->Flags = PF_EDITOR | PF_VIEWER | PF_FULLCMDLINE;
		Info->DiskMenuStringsNumber = 0;
		Info->PluginConfigStringsNumber = 0;
		PluginMenuStrings[0] = GetMsg (MTitle);
		Info->PluginMenuStrings = PluginMenuStrings;
		Info->PluginMenuStringsNumber = 1;

		static const char *PluginCfgStrings[1];
		PluginCfgStrings[0] = GetMsg (MTitle);
		Info->PluginConfigStrings = PluginCfgStrings;
		Info->PluginConfigStringsNumber = dimOf (PluginCfgStrings);

		static const char *PluginPrefix = GetMsg (MPrefix);
		Info->CommandPrefix = PluginPrefix;
	}
}

int WINAPI _export Configure (int ItemNumber)
{
	if (ItemNumber) return (false);
	return (Config ());
}

int WINAPI _export ProcessEditorEvent (int Event, void *Param)
{
	static INPUT_RECORD dummy;
	EditorInfo					ei;
	initEList ();
	switch (Event)
	{
	case EE_READ:
		Info.EditorControl (ECTL_GETINFO, &ei);
		eListInsert (&ei);
		memset (&dummy, 0, sizeof (dummy));
		dummy.EventType = KEY_EVENT;
		dummy.Event.KeyEvent.bKeyDown = true;
		Info.EditorControl (ECTL_PROCESSINPUT, &dummy);
		return (0);
	case EE_CLOSE:
		eList->removeID (*((int *) Param));
		return (0);
	case EE_REDRAW:
		if (reloadNeeded)
		{
			reloadInProcess = true;
			DoneMacro ();
			InitMacro ();
		}

		return (0);
	default:
		return (0);
	}
}

static void SelectTemplate (TEInfo *te)
{
	if (te)
	{
		TLang *lng = (TLang *) (langColl[te->lang]);
		if (lng)
		{
			unsigned	count = 0;
			for (unsigned i = 0; i < lng->macroColl.getCount (); i++)
			{
				TMacro	*mm = (TMacro *) (lng->macroColl[i]);
				if (mm->Name[0] && !mm->submenu) count++;
			}

			if (count > 0)
			{
				FarMenuItem *amenu = new FarMenuItem[count];
				if (amenu)
				{
					count = 0;
					for (unsigned i = 0; i < lng->macroColl.getCount (); i++)
					{
						TMacro	*mm = (TMacro *) (lng->macroColl[i]);
						if (mm->Name[0] && !mm->submenu)
						{
							FSF.sprintf (amenu[count].Text, "%s", mm->Name);
							amenu[count].Selected = false;
							amenu[count].Checked = amenu[count].Separator = false;
							count++;
						}
					}

					int res = Info.Menu
						(
							Info.ModuleNumber,
							-1,
							-1,
							0,
							FMENU_WRAPMODE,
							GetMsg (MSelectMacro),
							NULL,
							NULL,
							NULL,
							NULL,
							amenu,
							count
						);
					if (res != -1)
					{
						count = 0;
						for (unsigned i = 0; i < lng->macroColl.getCount (); i++)
						{
							TMacro	*mm = (TMacro *) (lng->macroColl[i]);
							if (mm->Name[0] && !mm->submenu)
							{
								if (count == res)
								{
									TMacro			*fm = (TMacro *) (lng->macroColl[i]);
									char				line[MAX_STR_LEN];
									EditorInfo	ei;
									Info.EditorControl (ECTL_GETINFO, &ei);

									EditorGetString gs;
									TEditorPos			epos = EditorGetPos ();
									EditorGetStr (&gs);
									Editor2OEM (&ei, lstrcpyn (line, gs.StringText, gs.StringLength + 1));
									if (!inComment (lng, line, epos.Col))
									{
										char	before[MAX_STR_LEN], *after = line + epos.Col;
										lstrcpy (before, line);
										before[epos.Col] = 0;
										if (ignoreposn)
										{
											if (checkMultipleChoice (lng, fm, "", "", 0, NULL))
											{
												RunMacro (fm, NULL, NULL);
												redraw ();
											}
										}
										else if (CheckMacroPos (lng, fm, before, after))
											if (checkMultipleChoice (lng, fm, before, after, 0, NULL))
											{
												RunMacro (fm, NULL, NULL);
												redraw ();
											}
									}
									break;
								}

								count++;
							}
						}
					}

					delete[] amenu;
				}
			}
		}
	}
}

static void SelectTemplateSet (TEInfo *te)
{
	unsigned		lc = langColl.getCount ();
	FarMenuItem *amenu = new FarMenuItem[lc + 2];
	if (amenu)
	{
		for (unsigned i = 0; i < lc; i++)
		{
			FSF.sprintf (amenu[i].Text, "%s", ((TLang *) langColl[i])->desc);
			amenu[i].Selected = (unsigned) (te->lang) == i;
			amenu[i].Checked = amenu[i].Separator = false;
		}

		amenu[lc].Selected = amenu[lc].Checked = false;
		amenu[lc].Separator = true;
		*amenu[lc].Text = 0;
		FSF.sprintf (amenu[lc + 1].Text, "%s", GetMsg (MOtherLang));
		amenu[lc + 1].Selected = te->lang == -1;
		amenu[lc + 1].Checked = amenu[lc + 1].Separator = false;

		int res = Info.Menu
			(
				Info.ModuleNumber,
				-1,
				-1,
				0,
				FMENU_WRAPMODE | FMENU_AUTOHIGHLIGHT,
				GetMsg (MSelectLang),
				NULL,
				NULL,
				NULL,
				NULL,
				amenu,
				lc + 2
			);
		if (res != -1)
		{
			if (pluginStop) SetRegKey (HKEY_CURRENT_USER, "", "Disable", pluginStop = 0);
			te->lang = ((unsigned) res < lc) ? res : -1;
		}

		delete[] amenu;
	}
}

HANDLE WINAPI _export OpenPlugin (int OpenFrom, int item)
{
	if (!IsOldFar)
	{
		int					n;
		EditorInfo	ei;
		WindowInfo	wi;
		switch (OpenFrom)
		{
		case OPEN_VIEWER:
			wi.Pos = -1;
			Info.AdvControl (Info.ModuleNumber, ACTL_GETWINDOWINFO, &wi);
			n = findLngID (wi.Name);
			if (n != -1) CompilerMenu (NULL, wi.Name, n);
			break;
		case OPEN_SHORTCUT:
		case OPEN_COMMANDLINE:
			char tmp[NM];
			lstrcpyn (tmp, (char *) item, NM);
			FSF.Unquote (tmp);
			if (tmp[2] == 'l')
			{
				n = findLngID (tmp + 4);
				if (n != -1) CompilerMenu (NULL, tmp + 4, n);
			}

			if (tmp[2] == 'f')
			{
				n = findLngID (tmp + 4);
				if (n != -1) FormatMenu (tmp + 4, n);
			}
			break;
		case OPEN_EDITOR:
			Info.EditorControl (ECTL_GETINFO, &ei);
			initEList ();
			n = eList->findID (ei.EditorID);
			if (n == -1) n = eListInsert (&ei);
			if (n != -1)
			{
				TEInfo	*te = (TEInfo *) (*eList)[n];
				if (te)
				{
					FarMenuItemEx mMenu[9];
					int						count = dimOf (mMenu);
					for (int i = 0; i < count; i++) mMenu[i].Flags = 0;
					lstrcpy (mMenu[0].Text.Text, GetMsg (MMenuTemplates));
					lstrcpy (mMenu[1].Text.Text, GetMsg (MFormatting));
					lstrcpy (mMenu[2].Text.Text, GetMsg (MNavigation));
					lstrcpy (mMenu[3].Text.Text, GetMsg (MNavigationList));
					lstrcpy (mMenu[4].Text.Text, GetMsg (MComments));
					lstrcpy (mMenu[5].Text.Text, GetMsg (MMenuSelectLang));
					lstrcpy (mMenu[6].Text.Text, GetMsg (MMenuCompile));
					lstrcpy (mMenu[8].Text.Text, GetMsg (MShowOutput));
					mMenu[7].Text.TextPtr = NULL;
					mMenu[7].Flags |= MIF_SEPARATOR;
					if (!compilerOut) mMenu[8].Flags |= MIF_DISABLE;

					int mode = Info.Menu
						(
							Info.ModuleNumber,
							-1,
							-1,
							0,
							FMENU_WRAPMODE | FMENU_USEEXT,
							GetMsg (MTitle),
							NULL,
							NULL,
							NULL,
							NULL,
							(const FarMenuItem *) mMenu,
							count
						);
					switch (mode)
					{
					case 0:
						SelectTemplate (te);
						break;
					case 1:
						SelectFormatting (te);
						break;
					case 2:
						SelectNavigation (te);
						break;
					case 3:
						SelectNavigationList (te);
						break;
					case 4:
						BlockComments (te);
						break;
					case 5:
						SelectTemplateSet (te);
						break;
					case 6:
						SelectCompiler (te);
						break;
					case 8:
						ShowOutput ();
						break;
					}
				}
			}
			break;
		case OPEN_PLUGINSMENU:
			FarMenuItemEx mMenu[3];

			int count = dimOf (mMenu);
			for (int i = 0; i < count; i++) mMenu[i].Flags = 0;
			lstrcpy (mMenu[0].Text.Text, GetMsg (MMenuCompile));
			lstrcpy (mMenu[2].Text.Text, GetMsg (MShowOutput));
			mMenu[1].Text.TextPtr = NULL;
			mMenu[1].Flags |= MIF_SEPARATOR;
			if (!compilerOut) mMenu[2].Flags |= MIF_DISABLE;

			int mode = Info.Menu
				(
					Info.ModuleNumber,
					-1,
					-1,
					0,
					FMENU_WRAPMODE | FMENU_USEEXT,
					GetMsg (MTitle),
					NULL,
					NULL,
					NULL,
					NULL,
					(const FarMenuItem *) mMenu,
					count
				);
			switch (mode)
			{
			case 0:
				PanelInfo PInfo;
				if (Info.Control (INVALID_HANDLE_VALUE, FCTL_CHECKPANELSEXIST, &PInfo) == TRUE)
				{
					Info.Control (INVALID_HANDLE_VALUE, FCTL_GETPANELINFO, &PInfo);
					if (PInfo.ItemsNumber > 0)
					{
						char	buf[NM];
						strcpy (buf, PInfo.CurDir);
						strcat (buf, "\\");
						strcat (buf, PInfo.PanelItems[PInfo.CurrentItem].FindData.cFileName);
						n = findLngID (buf);
						if (n != -1) CompilerMenu (NULL, buf, n);
					}
				}
				break;
			case 2:
				ShowOutput ();
				break;
			}
			break;
		}
	}

	return (INVALID_HANDLE_VALUE);
}

void WINAPI _export ExitFAR ()
{
	DoneMacro ();
	if (eList)
	{
		eList->done ();
		delete eList;
	}

	if (compilerOut)
	{
		delete[] compilerOut;
		compilerOut = NULL;
	}

	if (errColl)
	{
		errColl->done ();
		delete errColl;
	}
}

BOOL WINAPI DllMain (HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved)
{
	switch (fdwReason)
	{
	case DLL_PROCESS_ATTACH:
		hInst = hinstDLL;
		GetModuleFileName (hInst, szIni, _MAX_PATH);
		lstrcpy (Point2FileExt (szIni), "ini");
	default:
		break;
	}

	return (TRUE);
}
