#define USER_INPUT_LENGTH 512
#define USER_CHECK				0
#define USER_COMBO				1
#define USER_DROPDOWN			2
#define USER_EDIT					3
#define USER_FIXEDIT			4
#define USER_LIST					5
#define USER_RADIO				6
#define USER_STATIC				7

static int	utypString[10] = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
static char userString[10][USER_INPUT_LENGTH] = { "", "", "", "", "", "", "", "", "", "" };
static char uttlString[10][USER_INPUT_LENGTH] = { "", "", "", "", "", "", "", "", "", "" };

static void nullUserStrings (void)
{
	for (int i = 0; i < 10; i++) utypString[i] = *userString[i] = *uttlString[i] = 0;
}

void unpackUserString (const char *userStr, char *format, int index)
{
	const char	*tmp = userStr;
	char				*tmpname = format;
	int					curindex = 0;
	*tmpname = '\0';
	while (*tmp)
	{
		if (tmp[0] == '\'')
		{
			tmp++;
			while (*tmp)
			{
				if ((tmp[0] == '\\') && ((tmp[1] == '\\') || (tmp[1] == '\'') || (tmp[1] == '?')))
				{
					tmp++;
					if (curindex == index)
						*tmpname++ = *tmp++;
					else
						tmp++;
				}
				else
				{
					if (*tmp == '\'')
					{
						tmp++;
						if (curindex == index)
						{
							*tmpname = '\0';
							return ;
						}
						else
							break;
					}
					else
					{
						if (curindex == index)
							*tmpname++ = *tmp++;
						else
							tmp++;
					}
				}
			}

			curindex++;
		}

		tmp++;
	}
}

static bool scanUserInput (bool inMacro, char macro, const char *MacroText, const char *title = NULL)
{
	int count = 0;
	nullUserStrings ();
	for (char *p = (char *) MacroText; *p; p++)
	{
		if (*p == macro)
		{
			//Getting user string type and argument string
			if (*++p == '?')
			{
				char	*tmp = p + 1;
				if (*tmp == '\'')
				{
					tmp++;

					char	*tmpname = uttlString[count];
					*tmpname = '\0';
					while (*tmp)
					{
						if ((tmp[0] == '\\') && ((tmp[1] == '\\') || (tmp[1] == '\'') || (tmp[1] == '?')))
						{
							tmp++;
							*tmpname++ = *tmp++;
						}
						else
						{
							if (*tmp == '\'')
							{
								tmp++;
								*tmpname = '\0';
								break;
							}
							else
								*tmpname++ = *tmp++;
						}
					}

					switch (*tmp)
					{
					case '?':
						utypString[count] = USER_STATIC;
						break;
					case 'x':
						tmp++;
						utypString[count] = USER_CHECK;
						break;
					case 'c':
						tmp++;
						utypString[count] = USER_COMBO;
						break;
					case 'd':
						tmp++;
						utypString[count] = USER_DROPDOWN;
						break;
					case 'e':
						tmp++;
						utypString[count] = USER_EDIT;
						break;
					case 'f':
						tmp++;
						utypString[count] = USER_FIXEDIT;
						break;
					case 'l':
						tmp++;
						utypString[count] = USER_LIST;
						break;
					case 'r':
						tmp++;
						utypString[count] = USER_RADIO;
						break;
					default:
						return (false);
					}

					tmpname = userString[count++];
					while (*tmp)
					{
						if ((tmp[0] == '\\') && ((tmp[1] == '\\') || (tmp[1] == '\'') || (tmp[1] == '?')))
						{
							*tmpname++ = *tmp++;
							*tmpname++ = *tmp++;
						}
						else
						{
							if (*tmp == '?')
							{
								tmp++;
								*tmpname = '\0';
								break;
							}
							else
								*tmpname++ = *tmp++;
						}
					}
				}

				p++;
				while (*p)
				{
					if ((p[0] == '\\') && ((p[1] == '\\') || (p[1] == '\'') || (p[1] == '?')))
					{
						p++;
						p++;
					}
					else
					{
						if (*p == '?')
							break;
						else
							p++;
					}
				}
			}
		}
	}

	//Calculating dialog items count
	int addlength = 0;
	int itemscount = 4;
	for (int i = 0; i < count; i++)
	{
		switch (utypString[i])
		{
		case USER_STATIC:
		case USER_CHECK:
			itemscount += 1;
			break;
		case USER_COMBO:
		case USER_DROPDOWN:
		case USER_EDIT:
		case USER_FIXEDIT:
			itemscount += 2;
			break;
		case USER_LIST:
			{
				addlength += 1;
				itemscount += 1;

				char	*tmp = userString[i];
				while (*tmp)
				{
					if
					(
						((tmp[0] != '\\') && (tmp[1] == '\'') && ((tmp[2] == '+') || (tmp[2] == '-')) && (tmp[3] == '\'')) ||
						((tmp == userString[i]) && ((tmp[0] == '+') || (tmp[0] == '-')) && ((tmp[1] == '\'')))
					) addlength += 1;
					tmp++;
				}
				break;
			}

		case USER_RADIO:
			{
				addlength += 1;
				itemscount += 1;

				char	*tmp = userString[i];
				while (*tmp)
				{
					if
					(
						((tmp[0] != '\\') && (tmp[1] == '\'') && ((tmp[2] == '+') || (tmp[2] == '-')) && (tmp[3] == '\'')) ||
						((tmp == userString[i]) && ((tmp[0] == '+') || (tmp[0] == '-')) && ((tmp[1] == '\'')))
					) itemscount += 1;
					tmp++;
				}
				break;
			}
		}
	}

	//Call dialog box
	bool	res = true;
	if (count == 0) return (res);

	struct InitDialogItemEx InitItem;
	struct FarDialogItem		*DialogItems = new FarDialogItem[itemscount];
	struct FarList					*listBox = new FarList[count];
	bool	*needFreeLists = new bool[count];
	for (int i = 0; i < count; i++)
	{
		needFreeLists[i] = false;
		listBox[i].ItemsNumber = 0;
		listBox[i].Items = NULL;
	}

	if (DialogItems != NULL)
	{
		int curDlgItem = 0;
		int curDlgPos = 2;

		//Dialog frame
		InitItem.Type = DI_DOUBLEBOX;
		InitItem.X1 = 3;
		InitItem.Y1 = 1;
		InitItem.X2 = 55;
		InitItem.Y2 = itemscount + addlength;
		InitItem.Focus = 0;
		InitItem.Selected = 0;
		InitItem.Flags = DIF_BOXCOLOR;
		InitItem.DefaultButton = 0;
		InitItem.Data = (title != NULL) ? title : GetMsg (MParams);
		InitItem.History = NULL;
		InitDialogItemsEx (&InitItem, DialogItems + curDlgItem++, 1);

		bool	gainfocus = true;
		char	format[USER_INPUT_LENGTH];
		for (int i = 0; i < count; i++)
		{
			switch (utypString[i])
			{
			case USER_STATIC:
				InitItem.Type = DI_TEXT;
				InitItem.X1 = 5;
				InitItem.Y1 = curDlgPos++;
				InitItem.X2 = 53;
				InitItem.Y2 = 0;
				InitItem.Focus = 0;
				InitItem.Selected = 0;
				InitItem.Flags = 0;
				InitItem.DefaultButton = 0;
				InitItem.Data = uttlString[i];
				InitItem.History = NULL;
				InitDialogItemsEx (&InitItem, DialogItems + curDlgItem++, 1);
				break;
			case USER_CHECK:
				{
					int		selected = 0;
					char	*tmp = userString[i];
					while (*tmp)
					{
						if ((tmp[0] != '\\') && (tmp[1] == '\'') && (tmp[2] == '+') && (tmp[3] == '\''))
						{
							selected = 1;
							break;
						}

						tmp++;
					}

					InitItem.Type = DI_CHECKBOX;
					InitItem.X1 = 5;
					InitItem.Y1 = curDlgPos++;
					InitItem.X2 = 53;
					InitItem.Y2 = 0;
					InitItem.Focus = (gainfocus) ? 1 : 0;
					InitItem.Selected = selected;
					InitItem.Flags = 0;
					InitItem.DefaultButton = 0;
					InitItem.Data = uttlString[i];
					InitItem.History = NULL;
					InitDialogItemsEx (&InitItem, DialogItems + curDlgItem++, 1);
					gainfocus = (gainfocus) ? false : gainfocus;
					break;
				}

			case USER_COMBO:
			case USER_DROPDOWN:
				{
					InitItem.Type = DI_TEXT;
					InitItem.X1 = 5;
					InitItem.Y1 = curDlgPos++;
					InitItem.X2 = 53;
					InitItem.Y2 = 0;
					InitItem.Focus = 0;
					InitItem.Selected = 0;
					InitItem.Flags = 0;
					InitItem.DefaultButton = 0;
					InitItem.Data = uttlString[i];
					InitItem.History = NULL;
					InitDialogItemsEx (&InitItem, DialogItems + curDlgItem++, 1);

					int		ic = 0;
					int		sel = -1;
					char	*tmp = userString[i];
					while (*tmp)
					{
						if
						(
							((tmp[0] != '\\') && (tmp[1] == '\'') && (tmp[2] == '+') && (tmp[3] == '\'')) ||
							((tmp == userString[i]) && (tmp[0] == '+') && (tmp[1] == '\''))
						) sel = ic++;
						if
						(
							((tmp[0] != '\\') && (tmp[1] == '\'') && (tmp[2] == '-') && (tmp[3] == '\'')) ||
							((tmp == userString[i]) && (tmp[0] == '-') && (tmp[1] == '\''))
						) ic++;
						tmp++;
					}

					if (ic > 0)
					{
						needFreeLists[i] = true;
						listBox[i].ItemsNumber = ic;
						listBox[i].Items = new FarListItem[ic];
					}

					for (int j = 0; j < ic; j++)
					{
						listBox[i].Items[j].Flags = (j == sel) ? LIF_SELECTED : 0;
						listBox[i].Items[j].Reserved[0] = 0;
						listBox[i].Items[j].Reserved[1] = 0;
						listBox[i].Items[j].Reserved[2] = 0;
						unpackUserString (userString[i], listBox[i].Items[j].Text, (utypString[i] == USER_COMBO) ? j : 3 * j);
					}

					InitItem.Type = DI_COMBOBOX;
					InitItem.X1 = 5;
					InitItem.Y1 = curDlgPos++;
					InitItem.X2 = 53;
					InitItem.Y2 = 0;
					InitItem.Focus = (gainfocus) ? 1 : 0;
					InitItem.Selected = (int) (&listBox[i]);
					InitItem.Flags = DIF_LISTAUTOHIGHLIGHT | DIF_LISTNOAMPERSAND | DIF_LISTWRAPMODE | ((utypString[i] == USER_COMBO) ? 0 : DIF_DROPDOWNLIST);
					InitItem.DefaultButton = 0;
					InitItem.Data = (sel < 0) ? "" : listBox[i].Items[sel].Text;
					InitItem.History = NULL;
					InitDialogItemsEx (&InitItem, DialogItems + curDlgItem++, 1);
					gainfocus = (gainfocus) ? false : gainfocus;
					break;
				}

			case USER_EDIT:
			case USER_FIXEDIT:
				{
					char	len[USER_INPUT_LENGTH];
					InitItem.Type = DI_TEXT;
					InitItem.X1 = 5;
					InitItem.Y1 = curDlgPos++;
					InitItem.X2 = 53;
					InitItem.Y2 = 0;
					InitItem.Focus = 0;
					InitItem.Selected = 0;
					InitItem.Flags = 0;
					InitItem.DefaultButton = 0;
					InitItem.Data = uttlString[i];
					InitItem.History = NULL;
					InitDialogItemsEx (&InitItem, DialogItems + curDlgItem++, 1);
					unpackUserString (userString[i], format, 0);
					if (utypString[i] == USER_FIXEDIT) unpackUserString (userString[i], len, 1);
					lstrcpy (userString[i], format);
					InitItem.Type = (utypString[i] == USER_EDIT) ? DI_EDIT : DI_FIXEDIT;
					InitItem.X1 = 5;
					InitItem.Y1 = curDlgPos++;
					InitItem.X2 = (utypString[i] == USER_EDIT) ? 53 : (5 + atoi (len) - 1);
					InitItem.Y2 = 0;
					InitItem.Focus = (gainfocus) ? 1 : 0;
					InitItem.Selected = 0;
					InitItem.Flags = DIF_HISTORY;
					InitItem.DefaultButton = 0;
					InitItem.Data = format;
					InitItem.History = (utypString[i] == USER_EDIT) ? "True-Tpl.History.UserInput.Edit" : "True-Tpl.History.UserInput.FixEdit";
					InitDialogItemsEx (&InitItem, DialogItems + curDlgItem++, 1);
					gainfocus = (gainfocus) ? false : gainfocus;
					break;
				}

			case USER_LIST:
				{
					int		ic = 0;
					int		sel = -1;
					char	*tmp = userString[i];
					while (*tmp)
					{
						if
						(
							((tmp[0] != '\\') && (tmp[1] == '\'') && (tmp[2] == '+') && (tmp[3] == '\'')) ||
							((tmp == userString[i]) && (tmp[0] == '+') && (tmp[1] == '\''))
						) sel = ic++;
						if
						(
							((tmp[0] != '\\') && (tmp[1] == '\'') && (tmp[2] == '-') && (tmp[3] == '\'')) ||
							((tmp == userString[i]) && (tmp[0] == '-') && (tmp[1] == '\''))
						) ic++;
						tmp++;
					}

					if (ic > 0)
					{
						needFreeLists[i] = true;
						listBox[i].ItemsNumber = ic;
						listBox[i].Items = new FarListItem[ic];
					}

					for (int j = 0; j < ic; j++)
					{
						listBox[i].Items[j].Flags = (j == sel) ? LIF_SELECTED : 0;
						listBox[i].Items[j].Reserved[0] = 0;
						listBox[i].Items[j].Reserved[1] = 0;
						listBox[i].Items[j].Reserved[2] = 0;
						unpackUserString (userString[i], listBox[i].Items[j].Text, 3 * j);
					}

					InitItem.Type = DI_LISTBOX;
					InitItem.X1 = 5;
					InitItem.Y1 = curDlgPos++;
					InitItem.X2 = 53;
					InitItem.Y2 = (curDlgPos += ic)++;
					InitItem.Focus = (gainfocus) ? 1 : 0;
					InitItem.Selected = (int) (&listBox[i]);
					InitItem.Flags = DIF_LISTAUTOHIGHLIGHT | DIF_LISTNOAMPERSAND | DIF_LISTWRAPMODE;
					InitItem.DefaultButton = 0;
					InitItem.Data = uttlString[i];
					InitItem.History = NULL;
					InitDialogItemsEx (&InitItem, DialogItems + curDlgItem++, 1);
					gainfocus = (gainfocus) ? false : gainfocus;
					break;
				}

			case USER_RADIO:
				{
					int		ic = 0;
					char	*tmp = userString[i];
					while (*tmp)
					{
						if
						(
							((tmp[0] != '\\') && (tmp[1] == '\'') && ((tmp[2] == '+') || (tmp[2] == '-')) && (tmp[3] == '\'')) ||
							((tmp == userString[i]) && ((tmp[0] == '+') || (tmp[0] == '-')) && ((tmp[1] == '\'')))
						) ic += 1;
						tmp++;
					}

					InitItem.Type = DI_SINGLEBOX;
					InitItem.X1 = 5;
					InitItem.Y1 = curDlgPos++;
					InitItem.X2 = 53;
					InitItem.Y2 = curDlgPos + ic;
					InitItem.Focus = 0;
					InitItem.Selected = 0;
					InitItem.Flags = 0;
					InitItem.DefaultButton = 0;
					InitItem.Data = uttlString[i];
					InitItem.History = NULL;
					InitDialogItemsEx (&InitItem, DialogItems + curDlgItem++, 1);
					ic = 0;
					tmp = userString[i];

					bool	selItem = false;
					bool	startGroup = true;
					while (*tmp)
					{
						if
						(
							((tmp[0] != '\\') && (tmp[1] == '\'') && (tmp[2] == '+') && (tmp[3] == '\'')) ||
							((tmp == userString[i]) && (tmp[0] == '+') && (tmp[1] == '\''))
						) selItem = true;
						if
						(
							((tmp[0] != '\\') && (tmp[1] == '\'') && (tmp[2] == '-') && (tmp[3] == '\'')) ||
							((tmp == userString[i]) && (tmp[0] == '-') && (tmp[1] == '\''))
						) selItem = false;
						if
						(
							((tmp[0] != '\\') && (tmp[1] == '\'') && ((tmp[2] == '+') || (tmp[2] == '-')) && (tmp[3] == '\'')) ||
							((tmp == userString[i]) && ((tmp[0] == '+') || (tmp[0] == '-')) && ((tmp[1] == '\'')))
						)
						{
							unpackUserString (userString[i], format, ic * 3);
							InitItem.Type = DI_RADIOBUTTON;
							InitItem.X1 = 6;
							InitItem.Y1 = curDlgPos++;
							InitItem.X2 = 52;
							InitItem.Y2 = 0;
							InitItem.Focus = (gainfocus) ? 1 : 0;
							InitItem.Selected = (selItem) ? 1 : 0;
							InitItem.Flags = (startGroup) ? DIF_GROUP : 0;
							InitItem.DefaultButton = 0;
							InitItem.Data = format;
							InitItem.History = NULL;
							InitDialogItemsEx (&InitItem, DialogItems + curDlgItem++, 1);
							gainfocus = (gainfocus) ? false : gainfocus;
							startGroup = (startGroup) ? false : startGroup;
							ic++;
						}

						tmp++;
					}

					curDlgPos++;
					break;
				}
			}
		}

		//Separator
		InitItem.Type = DI_TEXT;
		InitItem.X1 = 0;
		InitItem.Y1 = itemscount + addlength - 2;
		InitItem.X2 = 0;
		InitItem.Y2 = 0;
		InitItem.Focus = 0;
		InitItem.Selected = 0;
		InitItem.Flags = DIF_BOXCOLOR | DIF_SEPARATOR;
		InitItem.DefaultButton = 0;
		InitItem.Data = "";
		InitItem.History = NULL;
		InitDialogItemsEx (&InitItem, DialogItems + itemscount - 3, 1);

		//Button: Ok
		InitItem.Type = DI_BUTTON;
		InitItem.X1 = 0;
		InitItem.Y1 = itemscount + addlength - 1;
		InitItem.X2 = 0;
		InitItem.Y2 = 0;
		InitItem.Focus = 0;
		InitItem.Selected = 0;
		InitItem.Flags = DIF_CENTERGROUP;
		InitItem.DefaultButton = 1;
		InitItem.Data = GetMsg (MOK);
		InitItem.History = NULL;
		InitDialogItemsEx (&InitItem, DialogItems + itemscount - 2, 1);

		//Button: Cancel
		InitItem.Type = DI_BUTTON;
		InitItem.X1 = 0;
		InitItem.Y1 = itemscount + addlength - 1;
		InitItem.X2 = 0;
		InitItem.Y2 = 0;
		InitItem.Focus = 0;
		InitItem.Selected = 0;
		InitItem.Flags = DIF_CENTERGROUP;
		InitItem.DefaultButton = 0;
		InitItem.Data = GetMsg (MCancel);
		InitItem.History = NULL;
		InitDialogItemsEx (&InitItem, DialogItems + itemscount - 1, 1);

		int n = Info.Dialog (Info.ModuleNumber, -1, -1, 59, itemscount + addlength + 2, NULL, DialogItems, itemscount);
		if (n == itemscount - 2)
		{
			int curdialogitem = 1;
			for (int i = 0; i < count; i++)
			{
				switch (utypString[i])
				{
				case USER_STATIC:
					lstrcpy (userString[i], "");
					curdialogitem += 1;
					break;
				case USER_CHECK:
					unpackUserString (userString[i], format, (DialogItems[curdialogitem].Selected) ? 0 : 1);
					lstrcpy (userString[i], format);
					curdialogitem += 1;
					break;
				case USER_COMBO:
				case USER_DROPDOWN:
					lstrcpy (userString[i], DialogItems[curdialogitem + 1].Data);
					curdialogitem += 2;
					break;
				case USER_EDIT:
					lstrcpy (userString[i], DialogItems[curdialogitem + 1].Data);
					curdialogitem += 2;
					break;
				case USER_FIXEDIT:
					lstrcpy (userString[i], DialogItems[curdialogitem + 1].Data);
					curdialogitem += 2;
					break;
				case USER_LIST:
					{
						char	tmpList[USER_INPUT_LENGTH];
						char	*tmp = userString[i];
						int		ic = 0;
						strcpy (tmpList, "");
						while (*tmp)
						{
							if
							(
								((tmp[0] != '\\') && (tmp[1] == '\'') && ((tmp[2] == '+') || (tmp[2] == '-')) && (tmp[3] == '\'')) ||
								((tmp == userString[i]) && ((tmp[0] == '+') || (tmp[0] == '-')) && ((tmp[1] == '\'')))
							)
							{
								unpackUserString
								(
									userString[i],
									format,
									ic * 3 + ((DialogItems[curdialogitem].ListPos == ic) ? 1 : 2)
								);
								strcat (tmpList, format);
								ic++;
							}

							tmp++;
						}

						strcpy (userString[i], tmpList);
						curdialogitem += 1;
						break;
					}

				case USER_RADIO:
					{
						char	tmpRadio[USER_INPUT_LENGTH];
						char	*tmp = userString[i];
						int		ic = 0;
						strcpy (tmpRadio, "");
						while (*tmp)
						{
							if
							(
								((tmp[0] != '\\') && (tmp[1] == '\'') && ((tmp[2] == '+') || (tmp[2] == '-')) && (tmp[3] == '\'')) ||
								((tmp == userString[i]) && ((tmp[0] == '+') || (tmp[0] == '-')) && ((tmp[1] == '\'')))
							)
							{
								unpackUserString
								(
									userString[i],
									format,
									ic * 3 + ((DialogItems[curdialogitem + ic + 1].Selected) ? 1 : 2)
								);
								strcat (tmpRadio, format);
								ic++;
							}

							tmp++;
						}

						strcpy (userString[i], tmpRadio);
						curdialogitem += ic + 1;
						break;
					}
				}
			}
		}
		else
		{
			for (int i = 0; i < count; i++) lstrcpy (userString[i], "");
			res = false;
		}
	}

	for (int i = 0; i < count; i++)
		if (!needFreeLists[i]) delete[] listBox[i].Items;
	delete[] needFreeLists;
	delete[] listBox;
	delete[] DialogItems;
	return (res);
}
